'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _constants = require('./constants');

var _reduxActions = require('redux-actions');

var token = 'auth.token';
var profile = 'auth.profile';

exports.default = function (store) {
  return function (next) {
    return function (action) {
      var result = next(action);
      var t, p;
      var payload = action.payload;


      if (action.type == _constants.auth.check) {
        t = localStorage.getItem(token);
        if (t) {

          t = JSON.parse(t);
          p = JSON.parse(localStorage.getItem(profile));
          store.dispatch((0, _reduxActions.createAction)(_constants.auth.signin)({ profile: p, token: t }));
        }
      } else if (action.type == _constants.auth.signin) {
        localStorage.setItem(token, JSON.stringify(payload.token));
        localStorage.setItem(profile, JSON.stringify(payload.profile));
      } else if (action.type == _constants.auth.logout) {
        localStorage.removeItem(token);
        localStorage.removeItem(profile);
      }

      return result;
    };
  };
};